import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.URL;
import java.util.ResourceBundle;

import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Alert;
import javafx.scene.control.ButtonType;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.BorderPane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Polygon;
public class Controller implements Initializable {

	private GameState gameState;
	private Process gameProcess;
	private PrintWriter gameInput;
	private Plateau plateau;

	@FXML
	private Polygon case0, case1, case2, case3, case4, case5, case6, case7, case8, case9, case10, case11, case12, case13, case14, case15, case16, case17, case18, case19, case20, case21, case22, case23, case24, case25, case26, case27, case28, case29, case30, case31, case32, case33, case34, case35, case36, case37, case38, case39, case40, case41, case42, case43, case44, case45, case46, case47, case48, case49, case50, case51, case52, case53, case54, case55, case56, case57, case58, case59;

	@FXML
	private BorderPane panneauPrincipal;

	@Override
	public void initialize(URL location, ResourceBundle resources) {
		Polygon[] cases = {case0, case1, case2, case3, case4, case5, case6, case7, case8, case9, case10, case11, case12, case13, case14, case15, case16, case17, case18, case19, case20, case21, case22, case23, case24, case25, case26, case27, case28, case29, case30, case31, case32, case33, case34, case35, case36, case37, case38, case39, case40, case41, case42, case43, case44, case45, case46, case47, case48, case49, case50, case51, case52, case53, case54, case55, case56, case57, case58, case59};
		for(Polygon c : cases)
		{
			c.setOnMouseClicked(new MyClickHandler());
			c.setOnMouseEntered(new MyHexEnteredHandler());
		}
		this.plateau = new Plateau(cases);
		this.gameState = new GameState();
		try {
			this.gameProcess = new ProcessBuilder("../bin/theturk").start();
			gameInput = new PrintWriter(new OutputStreamWriter(gameProcess.getOutputStream()), true);
		} catch (IOException e) {
			Alert alert = new Alert(Alert.AlertType.ERROR,"Can't run penguin program", ButtonType.OK);
			alert.showAndWait();
			e.printStackTrace();
			System.exit(1);
		}
		UpdateThread upT = new UpdateThread(gameProcess, this.gameState);
		upT.setDaemon(true);
		upT.start();

		//We tell the game that we will start
		gameInput.print("h");
		gameInput.println();
	}

	//public Polygon getPolygonFromCoordinates(double x, double y){	}

	//Action de click sur case
	private class MyClickHandler implements EventHandler<MouseEvent> {
		@Override
		public void handle (MouseEvent event){
			Polygon poly = (Polygon)event.getSource();
			poly.setFill(Color.GOLD);
		}
	}

	private class MyHexEnteredHandler implements EventHandler<MouseEvent> {
		@Override
		public void handle (MouseEvent event){
			Polygon poly = (Polygon)event.getSource();
			poly.setFill(Color.GOLD);
		}
	}



}
