import javafx.application.Platform;
import javafx.scene.control.Alert;
import javafx.scene.control.ButtonType;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class UpdateThread extends Thread
{
	BufferedReader reader;
	GameState gameState;

	public UpdateThread(Process program, GameState gameState)
	{
		this.reader = new BufferedReader(new InputStreamReader(program.getInputStream()));
		this.gameState = gameState;
	}


	public void run()
	{
		boolean running = true;
		while(running)
			try
			{
				String line = reader.readLine();
				//System.out.println(line);
				if (line.contains("{"))
				{
					gameState.update(line.substring(line.indexOf("{"), line.lastIndexOf("}")+1));
					Platform.runLater(() ->
					{
						// TODO: 4/27/16 update GUI from state
					});
				}
			} catch (IOException e)
			{
				running = false;
				Platform.runLater(() ->
				{
					Alert alert = new Alert(Alert.AlertType.ERROR, "Error during reading from penguin program!", ButtonType.FINISH);
					e.printStackTrace();
					alert.showAndWait();
					System.exit(1);
				});
			}
	}
}
